﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Windows.Forms;

namespace Excel文件合并
{
    public partial class FrmExcel : Form
    {
        public FrmExcel()
        {
            InitializeComponent();
        }

        private void FrmExcel_Load(object sender, EventArgs e)
        {

        }

        DataTable dtExcel;
        DataTable dtExcel2;
        DataTable dtExcel3;

        string lastDirectory;

        private void btnOk_Click(object sender, EventArgs e)
        {
            try
            {
                List<string> sameCol = new List<string>();
                List<string> col = new List<string>();

                foreach (var item in dtExcel2.Columns)
                {
                    if (dtExcel.Columns.Contains(item.ToString()))
                    {
                        //表1、表2相同的字段
                        if (!sameCol.Contains(item.ToString()))
                        {
                            sameCol.Add(item.ToString());
                        }
                    }
                    else
                    {
                        //表2差异的字段
                        if (!col.Contains(item.ToString()))
                        {
                            col.Add(item.ToString());
                        }

                        //将表2差异的字段添加到新表
                        if (!dtExcel3.Columns.Contains(item.ToString()))
                        {
                            dtExcel3.Columns.Add(item.ToString());
                        }
                    }
                }

                if (!dtExcel.Columns.Contains("处理结果"))
                {
                    dtExcel.Columns.Add("处理结果");
                }

                if (!dtExcel2.Columns.Contains("处理结果"))
                {
                    dtExcel2.Columns.Add("处理结果");
                }

                if (!dtExcel3.Columns.Contains("处理结果"))
                {
                    dtExcel3.Columns.Add("处理结果");
                }

                Dictionary<string, string> dicSame = new Dictionary<string, string>();
                for (int i = 0; i < dtExcel.Rows.Count; i++)
                {
                    string value = "";
                    foreach (string co in sameCol)
                    {
                        value += dtExcel.Rows[i][co].ToString() + "|";
                    }
                    if (!dicSame.ContainsKey(value))
                    {
                        dicSame.Add(value, "");

                        //默认为匹配不到数据，后面匹配成功会正常修改状态
                        dtExcel3.Rows[i]["处理结果"] = "匹配不到数据";
                    }
                    else
                    {
                        dtExcel.Rows[i]["处理结果"] = "重复数据";
                        dtExcel3.Rows[i]["处理结果"] = "重复数据";
                    }
                }

                dicSame = new Dictionary<string, string>();
                for (int i = 0; i < dtExcel2.Rows.Count; i++)
                {
                    string value = "";
                    foreach (string co in sameCol)
                    {
                        value += dtExcel2.Rows[i][co].ToString() + "|";
                    }
                    if (!dicSame.ContainsKey(value))
                    {
                        dicSame.Add(value, "");
                    }
                    else
                    {
                        dtExcel2.Rows[i]["处理结果"] = "重复数据";
                    }
                }


                //以表2为主循环，表1的数据为基础数据，向新表插入数据
                for (int i = 0; i < dtExcel2.Rows.Count; i++)
                {
                    DataRow dr2 = dtExcel2.Rows[i];
                    if (dr2["处理结果"].ToString() == "重复数据")
                    {
                        //重复，将表2的记录以新行的形式插入到新表
                        DataRow d = dtExcel3.NewRow();
                        foreach (var item in dtExcel2.Columns)
                        {
                            d[item.ToString()] = dr2[item.ToString()];
                        }
                        d["处理结果"] = "重复数据";
                        dtExcel3.Rows.Add(d);
                        continue;
                    }

                    bool flag = true;
                    DataRow dr = null;
                    int index = 0;
                    for (int j = 0; j < dtExcel.Rows.Count; j++)
                    {
                        dr = dtExcel.Rows[j];
                        if (dr["处理结果"].ToString() == "重复数据")
                        {
                            continue;
                        }
                        flag = true;
                        foreach (string co in sameCol)
                        {
                            if (dr[co].ToString() != dr2[co].ToString())
                            {
                                flag = false;
                                break;
                            }
                        }
                        if (flag)
                        {
                            index = j;
                            break;
                        }
                    }
                    if (flag == true)
                    {
                        //两条数据相同，取出表2的字段插入到新表
                        foreach (string c in col)
                        {
                            dtExcel3.Rows[index][c] = dr2[c].ToString();
                        }
                        dtExcel3.Rows[index]["处理结果"] = "匹配成功";
                    }
                    else
                    {
                        //数据不相同，将表2的记录以新行的形式插入到新表
                        DataRow d = dtExcel3.NewRow();
                        foreach (var item in dtExcel2.Columns)
                        {
                            d[item.ToString()] = dr2[item.ToString()];
                        }
                        d["处理结果"] = "匹配不到数据";
                        dtExcel3.Rows.Add(d);
                    }
                }

                dgvExcel3.DataSource = this.dtExcel3;
                grpExcel3.Text = "合并后的数据：" + this.dtExcel3.Rows.Count.ToString() + "条";

                MessageBox.Show("合并完成，请选择保存结果文件的位置！", "温馨提示", MessageBoxButtons.OK, MessageBoxIcon.Information);

                FolderBrowserDialog fd = new FolderBrowserDialog();
                if (DialogResult.OK == fd.ShowDialog())
                {
                    string path = fd.SelectedPath + "\\组合结果.xls";
                    DataTable[] result = new DataTable[] { this.dtExcel3 };
                    Tool.T_Excel.TableToExcelForXLS2(result, path, new string[] { "Sheet1" });
                    if (DialogResult.Yes == MessageBox.Show("合并结果已经导出到：" + path + "，是否马上查看？", "温馨提示", MessageBoxButtons.YesNo, MessageBoxIcon.Question))
                    {
                        System.Diagnostics.Process.Start(path);

                        dtExcel = null;
                        dtExcel2 = null;
                        dtExcel3 = null;
                        dgvExcel.DataSource = null;
                        dgvExcel2.DataSource = null;
                        dgvExcel3.DataSource = null;
                        txtExcel.Text = "";
                        txtExcel2.Text = "";
                        grpExcel.Text = "表1数据：0条";
                        grpExcel2.Text = "表2数据：0条";
                        grpExcel3.Text = "合并后的数据：0条";
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        private void btnExcel_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "所有Excel文件|*.xls;*.xlsx";

            if (!string.IsNullOrWhiteSpace(lastDirectory))
            {
                fd.InitialDirectory = lastDirectory;
            }

            if (DialogResult.OK == fd.ShowDialog())
            {
                lastDirectory = System.IO.Path.GetDirectoryName(fd.FileName);

                txtExcel.Text = fd.FileName;
                System.IO.FileInfo file = new System.IO.FileInfo(fd.FileName);
                if (file.Extension.ToLower() == ".xls")
                {
                    dtExcel = Tool.T_Excel.ExcelToTableForXLS(fd.FileName);
                    dtExcel3 = Tool.T_Excel.ExcelToTableForXLS(fd.FileName);
                }
                if (file.Extension.ToLower() == ".xlsx")
                {
                    dtExcel = Tool.T_Excel.ExcelToTableForXLSX(fd.FileName);
                    dtExcel3 = Tool.T_Excel.ExcelToTableForXLSX(fd.FileName);
                }
                dgvExcel.DataSource = dtExcel;
                grpExcel.Text = "表1数据：" + dtExcel.Rows.Count.ToString() + "条";
            }
            else
            {
                txtExcel.Text = "";
                grpExcel.Text = "表1数据：0条";
                dgvExcel.DataSource = null;
            }
        }

        private void btnExcel2_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "所有Excel文件|*.xls;*.xlsx";
            if (!string.IsNullOrWhiteSpace(lastDirectory))
            {
                fd.InitialDirectory = lastDirectory;
            }

            if (DialogResult.OK == fd.ShowDialog())
            {
                lastDirectory = System.IO.Path.GetDirectoryName(fd.FileName);

                txtExcel2.Text = fd.FileName;
                System.IO.FileInfo file = new System.IO.FileInfo(fd.FileName);
                if (file.Extension.ToLower() == ".xls")
                {
                    dtExcel2 = Tool.T_Excel.ExcelToTableForXLS(fd.FileName);
                }
                if (file.Extension.ToLower() == ".xlsx")
                {
                    dtExcel2 = Tool.T_Excel.ExcelToTableForXLSX(fd.FileName);
                }
                dgvExcel2.DataSource = dtExcel2;
                grpExcel2.Text = "表2数据：" + dtExcel2.Rows.Count.ToString() + "条";
            }
            else
            {
                txtExcel2.Text = "";
                grpExcel2.Text = "表2数据：0条";
                dgvExcel2.DataSource = null;
            }
        }

        private void label3_Click(object sender, EventArgs e)
        {
            if (System.IO.File.Exists(Application.StartupPath + "\\模板\\Excel合并1.xlsx"))
            {
                System.Diagnostics.Process.Start(Application.StartupPath + "\\模板\\Excel合并1.xlsx");
            }
            else
            {
                MessageBox.Show("Excel合并1.xls文件不存在！");
            }
        }

        private void label4_Click(object sender, EventArgs e)
        {
            if (System.IO.File.Exists(Application.StartupPath + "\\模板\\Excel合并2.xlsx"))
            {
                System.Diagnostics.Process.Start(Application.StartupPath + "\\模板\\Excel合并2.xlsx");
            }
            else
            {
                MessageBox.Show("Excel合并2.xls文件不存在！");
            }
        }
    }
}
